/* ccgo: igs/parser/say.cc
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "say.hh"
#include <sstream>
#include <regexx.hh>
#define atms(i, j) (rx.match[i].atom[j].str())

using namespace igs;
using namespace parser;

// extern Say parser_say;
Say Say::parser_say(& Say::parser_say);

Parser * Say::id(Control * c) const
{
	if (c->get_num_cmd() != 51) return 0;
	Say * k = new Say(c);
	if (k->parse_head()) return k;
	delete k;
	return 0;
}

bool Say::parse_head()
{
	regexx::Regexx rx;
	if (! rx.exec(control->get_cmd_dat(), "Say in game (\\d+)")) return false;
	game = -1;
	std::istringstream(atms(0, 0)) >> game;
	if (game < 0) return false;
	return true;
}

Say::Say(Parser * p) :
	Parser(p)
{
}

Say::Say(Control * c) :
	Parser(c)
{
	complete = false;
}

Say::~Say()
{
}

bool Say::process()
{
	regexx::Regexx rx;
	if (complete) return false;
	if (control->get_line() == "") return true; // skip empty lines
	if (control->get_num_cmd() != 19) return false;
	if (! rx.exec(control->get_cmd_dat(), "\\*(\\S+)\\*: (.*)")) return false;
	std::string w = atms(0, 0) + ": " + atms(0, 1);
	control->message_kibitz(game, w);
	complete = true;
	return true;
}
